﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace Practikaoy.Models;

public partial class Sazonova2Context : DbContext
{
    public Sazonova2Context()
    {
    }

    public Sazonova2Context(DbContextOptions<Sazonova2Context> options)
        : base(options)
    {
    }

    public virtual DbSet<TbCuor> TbCuors { get; set; }

    public virtual DbSet<TbGender> TbGenders { get; set; }

    public virtual DbSet<TbRole> TbRoles { get; set; }

    public virtual DbSet<TbTcher> TbTchers { get; set; }

    public virtual DbSet<TbTherCour> TbTherCours { get; set; }

    public virtual DbSet<User> Users { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see http://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.local;Port=5432;Database=Sazonova2;Username=43P;Password=444444");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<TbCuor>(entity =>
        {
            entity.HasKey(e => e.IdCours).HasName("tb_cuors_pk");

            entity.ToTable("tb_cuors");

            entity.Property(e => e.IdCours)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_cours");
            entity.Property(e => e.NameCours)
                .HasColumnType("character varying")
                .HasColumnName("name_cours");
        });

        modelBuilder.Entity<TbGender>(entity =>
        {
            entity.HasKey(e => e.IdGender).HasName("tb_gender_pk");

            entity.ToTable("tb_gender");

            entity.Property(e => e.IdGender)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_gender");
            entity.Property(e => e.NameGender)
                .HasColumnType("character varying")
                .HasColumnName("name_gender");
        });

        modelBuilder.Entity<TbRole>(entity =>
        {
            entity.HasKey(e => e.IdRole).HasName("tb_role_pk");

            entity.ToTable("tb_role");

            entity.Property(e => e.IdRole)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_role");
            entity.Property(e => e.NameRole)
                .HasColumnType("character varying")
                .HasColumnName("name_role");
        });

        modelBuilder.Entity<TbTcher>(entity =>
        {
            entity.HasKey(e => e.IdTher).HasName("tb_tcher_pk");

            entity.ToTable("tb_tcher");

            entity.Property(e => e.IdTher)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_ther");
            entity.Property(e => e.BrDay)
                .HasColumnType("timestamp without time zone")
                .HasColumnName("br_day");
            entity.Property(e => e.Email)
                .HasColumnType("character varying")
                .HasColumnName("email");
            entity.Property(e => e.IdGender).HasColumnName("id_gender");
            entity.Property(e => e.Name)
                .HasColumnType("character varying")
                .HasColumnName("name");
            entity.Property(e => e.Patronimyc)
                .HasColumnType("character varying")
                .HasColumnName("patronimyc");
            entity.Property(e => e.Phone)
                .HasColumnType("character varying")
                .HasColumnName("phone");
            entity.Property(e => e.Surname)
                .HasColumnType("character varying")
                .HasColumnName("surname");
            entity.Property(e => e.Timer).HasColumnName("timer");

            entity.HasOne(d => d.IdGenderNavigation).WithMany(p => p.TbTchers)
                .HasForeignKey(d => d.IdGender)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("tb_tcher_fk");
        });

        modelBuilder.Entity<TbTherCour>(entity =>
        {
            entity.HasKey(e => e.IdCic).HasName("tb_ther_cours_pk");

            entity.ToTable("tb_ther_cours");

            entity.Property(e => e.IdCic)
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_cic");
            entity.Property(e => e.Horsses).HasColumnName("horsses");
            entity.Property(e => e.IdCours).HasColumnName("id_cours");
            entity.Property(e => e.IdTher).HasColumnName("id_ther");

            entity.HasOne(d => d.IdCoursNavigation).WithMany(p => p.TbTherCours)
                .HasForeignKey(d => d.IdCours)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("tb_ther_cours_fk_1");

            entity.HasOne(d => d.IdTherNavigation).WithMany(p => p.TbTherCours)
                .HasForeignKey(d => d.IdTher)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("tb_ther_cours_fk");
        });

        modelBuilder.Entity<User>(entity =>
        {
            entity.HasKey(e => e.IdUser).HasName("user_pk");

            entity.ToTable("user");

            entity.Property(e => e.IdUser)
                .ValueGeneratedOnAdd()
                .UseIdentityAlwaysColumn()
                .HasColumnName("id_user");
            entity.Property(e => e.IdRole).HasColumnName("id_role");
            entity.Property(e => e.Login)
                .HasColumnType("character varying")
                .HasColumnName("login");
            entity.Property(e => e.Passs)
                .HasColumnType("character varying")
                .HasColumnName("passs");

            entity.HasOne(d => d.IdRoleNavigation).WithMany(p => p.Users)
                .HasForeignKey(d => d.IdRole)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("user_fk");

            entity.HasOne(d => d.IdUserNavigation).WithOne(p => p.User)
                .HasForeignKey<User>(d => d.IdUser)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("user_app");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
